2 # Submit a problem report to a GNATS site.
3 # Copyright (C) 1993, 2000, 2001, 2002, 2003 Free Software Foundation, Inc.
4 # Contributed by Brendan Kehoe (brendan@cygnus.com), based on a
5 # version written by Heinz G. Seidl (hgs@cygnus.com).
7 # This file is part of GNU GNATS.
9 # GNU GNATS is free software; you can redistribute it and/or modify
10 # it under the terms of the GNU General Public License as published by
11 # the Free Software Foundation; either version 2, or (at your option)
14 # GNU GNATS is distributed in the hope that it will be useful,
15 # but WITHOUT ANY WARRANTY; without even the implied warranty of
16 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
17 # GNU General Public License for more details.
19 # You should have received a copy of the GNU General Public License
20 # along with GNU GNATS; see the file COPYING. If not, write to
21 # the Free Software Foundation, 51 Franklin Street, Fifth Floor,
22 # Boston, MA 02110-1301, USA.
24 # The version of this send-pr.
27 # The submitter-id for your site.
30 # The default mail address for PR submissions.
31 GNATS_ADDR
=gcc-gnats@gcc.gnu.org
33 # The default release for this host.
34 # We have to guess at what program_transform_name might have done.
35 # "sed 1q" because neither "head -1" nor "head -n 1" is universal, argh.
37 DEFAULT_GCC
="`echo $0 | sed -e 's/bug//'`"
38 DEFAULT_RELEASE
="`$DEFAULT_GCC --version | sed 1q`"
40 # The default organization.
43 # What mailer to use. This must come after the config file, since it is
46 if [ -f /usr
/sbin
/sendmail
]; then
47 MAIL_AGENT
="/usr/sbin/sendmail -oi -t"
49 MAIL_AGENT
="/usr/lib/sendmail -oi -t"
51 MAILER
=`echo $MAIL_AGENT | sed -e 's, .*,,'`
52 if [ ! -f "$MAILER" ] ; then
53 echo "$COMMAND: Cannot file mail program \"$MAILER\"."
54 echo "$COMMAND: Please fix the MAIL_AGENT entry in the $COMMAND file."
59 # How to read the passwd database.
60 PASSWD
="cat /etc/passwd"
64 if [ $ECHON = bsd
] ; then
67 elif [ $ECHON = sysv
] ; then
77 if [ -z "$TMPDIR" ]; then
80 if [ "`echo $TMPDIR | grep '/$'`" != "" ]; then
81 TMPDIR
="`echo $TMPDIR | sed -e 's,/$,,'`"
85 if [ @have_mktemp_command@
= yes ]; then
86 TEMP0
=`mktemp $TMPDIR/poXXXXXX` ||
exit 1
87 TEMP
=`mktemp $TMPDIR/pXXXXXX` ||
exit 1
88 BAD
=`mktemp $TMPDIR/pbadXXXXXX` ||
exit 1
89 REF
=`mktemp $TMPDIR/pfXXXXXX` ||
exit 1
90 REMOVE_TEMP
="rm -f $TEMP0 $TEMP $BAD $REF"
97 mkdir
$TEMPD ||
exit 1
98 REMOVE_TEMP
="rm -rf $TEMPD"
102 if [ "$LOGNAME" = "" ]; then
103 if [ "$USER" != "" ]; then
111 REPLY_TO
="${REPLY_TO:-${REPLYTO:-$LOGNAME}}"
113 # Find out the name of the originator of this PR.
114 if [ -n "$NAME" ]; then
116 elif [ -f $HOME/.fullname
]; then
117 ORIGINATOR
="`sed -e '1q' $HOME/.fullname`"
119 # Must use temp file due to incompatibilities in quoting behavior
120 # and to protect shell metacharacters in the expansion of $LOGNAME
121 $PASSWD |
grep "^$LOGNAME:" |
awk -F: '{print $5}' |
sed -e 's/,.*//' > $TEMP0
122 ORIGINATOR
="`cat $TEMP0`"
126 if [ -n "$ORGANIZATION" ]; then
127 if [ -f "$ORGANIZATION" ]; then
128 ORGANIZATION
="`cat $ORGANIZATION`"
131 if [ -n "$DEFAULT_ORGANIZATION" ]; then
132 ORGANIZATION
="$DEFAULT_ORGANIZATION"
133 elif [ -f $HOME/.organization
]; then
134 ORGANIZATION
="`cat $HOME/.organization`"
138 # If they don't have a preferred editor set, then use
139 if [ -z "$VISUAL" ]; then
140 if [ -z "$EDITOR" ]; then
149 # Find out some information.
150 SYSTEM
=`( [ -f /bin/uname ] && /bin/uname -a ) || \
151 ( [ -f /usr/bin/uname ] && /usr/bin/uname -a ) || echo ""`
152 ARCH
=`[ -f /bin/arch ] && /bin/arch`
153 MACHINE
=`[ -f /bin/machine ] && /bin/machine`
155 COMMAND
=`echo $0 | sed -e 's,.*/,,'`
156 USAGE
="Usage: $COMMAND [-PVL] [-t address] [-f filename] [-s severity]
157 [-c address] [--request-id] [--version]"
163 while [ $# -gt 0 ]; do
165 -r) ;; # Ignore for backward compat.
166 -t |
--to) if [ $# -eq 1 ]; then echo "$USAGE"; $REMOVE_TEMP; exit 1; fi
167 shift ; GNATS_ADDR
="$1"
168 EXPLICIT_GNATS_ADDR
=true
170 -f |
--file) if [ $# -eq 1 ]; then echo "$USAGE"; $REMOVE_TEMP; exit 1; fi
172 if [ "$IN_FILE" != "-" -a ! -r "$IN_FILE" ]; then
173 echo "$COMMAND: cannot read $IN_FILE"
178 -b |
--batch) BATCH
=true
;;
179 -c |
--cc) if [ $# -eq 1 ]; then echo "$USAGE"; $REMOVE_TEMP; exit 1; fi
182 -s |
--severity) if [ $# -eq 1 ]; then echo "$USAGE"; $REMOVE_TEMP; exit 1; fi
183 shift ; SEVERITY_C
="$1"
185 -p |
-P |
--print) PRINT
=true
;;
186 -L |
--list) FORMAT
=norm
;;
187 -l |
-CL |
--lisp) FORMAT
=lisp
;;
188 --request-id) REQUEST_ID
=true
;;
189 -h |
--help) echo "$USAGE"; $REMOVE_TEMP; exit 0 ;;
190 -V |
--version) cat <<EOF
191 gccbug (GCC) $DEFAULT_RELEASE
192 Copyright (C) 2002 Free Software Foundation, Inc.
193 This is free software; see the source for copying conditions. There is NO
194 warranty; not even for MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
197 $REMOVE_TEMP; exit 0 ;;
198 -*) echo "$USAGE" ; $REMOVE_TEMP; exit 1 ;;
199 *) echo "$USAGE" ; $REMOVE_TEMP; exit 1
204 # spam does not need to be listed here
205 CATEGORIES
="ada bootstrap c++ c debug driver fortran inline-asm java libgcj libobjc libstdc++ middle-end objc other pch preprocessor rtl-optimization target tree-optimization web"
208 lisp
) echo "$CATEGORIES" | \
209 awk 'BEGIN {printf "( "} {printf "(\"%s\") ",$0} END {printf ")\n"}'
213 norm
) l
=`echo "$CATEGORIES" | \
214 awk 'BEGIN {max = 0; } { if (length($0) > max) { max = length($0); } }
215 END {print max + 1;}'`
217 if [ $c -eq 0 ]; then c
=1; fi
218 echo "$CATEGORIES" | \
219 awk 'BEGIN {print "Known categories:"; i = 0 }
220 { printf ("%-'$l'.'$l's", $0); if ((++i % '$c') == 0) { print "" } }
227 ORIGINATOR_C
='<name of the PR author (one line)>'
228 ORGANIZATION_C
='<organization of PR author (multiple lines)>'
229 SYNOPSIS_C
='<synopsis of the problem (one line)>'
230 if [ -z "$SEVERITY_C" ]; then
231 SEVERITY_C
='<[ non-critical | serious | critical ] (one line)>'
233 PRIORITY_C
='<[ low | medium ] (one line)>'
234 CATEGORY_C
='<choose from the top of this file (one line)>'
235 RELEASE_C
='<release number or tag (one line)>'
236 ENVIRONMENT_C
='<machine, os, target, libraries (multiple lines)>'
237 DESCRIPTION_C
='<precise description of the problem (multiple lines)>'
238 HOW_TO_REPEAT_C
='<When reporting a compiler error, preprocessor output must be included>'
239 FIX_C
='<how to correct or work around the problem, if known (multiple lines)>'
241 # Catch some signals. ($xs kludge needed by Sun /bin/sh)
243 trap '$REMOVE_TEMP; exit $xs' 0
244 trap 'echo "$COMMAND: Aborting ..."; $REMOVE_TEMP; xs=1; exit' 1 3 13 15
246 # If they told us to use a specific file, then do so.
247 if [ -n "$IN_FILE" ]; then
248 if [ "$IN_FILE" = "-" ]; then
249 # The PR is coming from the standard input.
250 if [ -n "$EXPLICIT_GNATS_ADDR" ]; then
251 sed -e "s;^[Tt][Oo]:.*;To: $GNATS_ADDR;" > $TEMP
256 # Use the file they named.
257 if [ -n "$EXPLICIT_GNATS_ADDR" ]; then
258 sed -e "s;^[Tt][Oo]:.*;To: $GNATS_ADDR;" $IN_FILE > $TEMP
265 if [ -n "$PR_FORM" -a -z "$PRINT_INTERN" ]; then
266 # If their PR_FORM points to a bogus entry, then bail.
267 if [ ! -f "$PR_FORM" -o ! -r "$PR_FORM" -o ! -s "$PR_FORM" ]; then
268 echo "$COMMAND: can't seem to read your template file (\`$PR_FORM'), ignoring PR_FORM"
270 PRINT_INTERN
=bad_prform
274 if [ -n "$PR_FORM" -a -z "$PRINT_INTERN" ]; then
276 ( echo "$COMMAND: could not copy $PR_FORM" ; xs
=1; exit )
278 for file in $TEMP $REF ; do
279 cat > $file << '__EOF__'
280 SEND-PR
: -*- send-pr
-*-
281 SEND-PR
: Lines starting with
`SEND-PR' will be removed automatically, as
282 SEND-PR: will all comments (text enclosed in `<' and `>').
284 SEND-PR
: Please consult the GCC manual
if you are not sure how to
285 SEND-PR
: fill out a problem report.
286 SEND-PR
: Note that the Synopsis field is mandatory. The Subject
(for
287 SEND-PR
: the
mail) will be made the same as Synopsis unless explicitly
290 SEND-PR
: Choose from the following categories
:
294 # Format the categories so they fit onto lines.
295 l
=`echo "$CATEGORIES" | \
296 awk 'BEGIN {max = 0; } { if (length($0) > max) { max = length($0); } }
297 END {print max + 1;}'`
299 if [ $c -eq 0 ]; then c
=1; fi
300 echo "$CATEGORIES" | \
301 awk 'BEGIN {printf "SEND-PR: "; i = 0 }
302 { printf ("%-'$l'.'$l's", $0);
303 if ((++i % '$c') == 0) { printf "\nSEND-PR: " } }
304 END { printf "\nSEND-PR:\n"; }' >> $file
306 cat >> $file << __EOF__
312 X-send-pr-version: $VERSION
316 >Submitter-Id: $SUBMITTER
317 >Originator: $ORIGINATOR
318 >Organization: ${ORGANIZATION-$ORGANIZATION_C}
320 SEND-PR: Leave "Confidential" as "no"; all GCC PRs are public.
321 >Synopsis: $SYNOPSIS_C
322 >Severity: $SEVERITY_C
323 SEND-PR: critical GCC is completely not operational; no work-around known.
324 SEND-PR: serious GCC is not working properly; a work-around is possible.
325 SEND-PR: non-critical Report indicates minor problem.
326 >Priority: $PRIORITY_C
327 SEND-PR: medium The problem should be solved in the next release.
328 SEND-PR: low The problem should be solve in a future release.
329 >Category: $CATEGORY_C
330 >Class: <[ doc-bug | accepts-illegal | rejects-legal | wrong-code | ice-on-legal-code| ice-on-illegal-code | pessimizes-code | sw-bug | change-request | support ] (one line)>
331 SEND-PR: doc-bug The documentation is incorrect.
332 SEND-PR: accepts-illegal GCC fails to reject erroneous code.
333 SEND-PR: rejects-legal GCC gives an error message for correct code.
334 SEND-PR: wrong-code The machine code generated by gcc is incorrect.
335 SEND-PR: ice-on-legal-code GCC gives an Internal Compiler Error (ICE)
336 SEND-PR: for correct code
337 SEND-PR: ice-on-illegal-code GCC gives an ICE instead of reporting an error
338 SEND-PR: pessimizes-code GCC misses an important optimization opportunity
339 SEND-PR: sw-bug Software bug of some other class than above
340 SEND-PR: change-request A feature in GCC is missing.
341 SEND-PR: support I need help with gcc.
342 >Release: ${DEFAULT_RELEASE-$RELEASE_C}
344 `[ -n "$SYSTEM" ] && echo System: $SYSTEM`
345 `[ -n "$ARCH" ] && echo Architecture: $ARCH`
346 `[ -n "$MACHINE" ] && echo Machine: $MACHINE`
352 cat >> $file << \__EOF__
353 configured with
: @gcc_config_arguments@
355 cat >> $file << __EOF__
366 if [ "$PRINT" = true
-o "$PRINT_INTERN" = true
]; then
372 if [ -z "$REQUEST_ID" ]; then
375 ed
-s $TEMP << '__EOF__'
376 /^Subject
/s
/^Subject
:.
*/Subject
: request
for a customer id
/
377 /^
>Category
/s
/^
>Category
:.
*/>Category
: send-pr
/
383 if cmp -s $REF $TEMP ; then
384 echo "$COMMAND: problem report not filled out, therefore not sent"
390 # Check the enumeration fields
392 # This is a "sed-subroutine" with one keyword parameter
393 # (with workaround for Sun sed bug)
406 while [ -z "$REQUEST_ID" ]; do
411 PATTERN
=">Confidential:"
412 CONFIDENTIAL
=`eval sed -n -e "\"$SED_CMD\"" $TEMP`
413 case "$CONFIDENTIAL" in
414 no
) CNT
=`expr $CNT + 1` ;;
415 *) echo "$COMMAND: \`$CONFIDENTIAL' is not a valid value for \`Confidential'." ;;
421 SEVERITY
=`eval sed -n -e "\"$SED_CMD\"" $TEMP`
423 ""|non-critical|serious|critical
) CNT
=`expr $CNT + 1` ;;
424 *) echo "$COMMAND: \`$SEVERITY' is not a valid value for \`Severity'."
430 PRIORITY
=`eval sed -n -e "\"$SED_CMD\"" $TEMP`
432 ""|low|medium
) CNT
=`expr $CNT + 1` ;;
433 high
) echo "$COMMAND: \`Priority: high' is reserved for GCC maintainers." ;;
434 *) echo "$COMMAND: \`$PRIORITY' is not a valid value for \`Priority'."
440 CATEGORY
=`eval sed -n -e "\"$SED_CMD\"" $TEMP`
444 if [ "$C" = "$CATEGORY" ]; then FOUND
=true
; break ; fi
446 if [ -n "$FOUND" ]; then
449 if [ -z "$CATEGORY" ]; then
450 echo "$COMMAND: you must include a Category: field in your report."
452 echo "$COMMAND: \`$CATEGORY' is not a known category."
459 CLASS
=`eval sed -n -e "\"$SED_CMD\"" $TEMP`
461 ""|doc-bug|accepts-illegal|rejects-legal|wrong-code|ice-on-legal-code|ice-on-illegal-code|pessimizes-code|sw-bug|change-request|support
) CNT
=`expr $CNT + 1` ;;
462 *) echo "$COMMAND: \`$CLASS' is not a valid value for \`Class'."
465 # 6) Check that synopsis is not empty
467 if grep "^>Synopsis:[ ]*${SYNOPSIS_C}\$" $TEMP > /dev
/null
469 echo "$COMMAND: Synopsis must not be empty."
474 [ $CNT -lt 6 -a -z "$BATCH" ] &&
475 echo "Errors were found with the problem report."
478 if [ -z "$BATCH" ]; then
479 $ECHON1 "a)bort, e)dit or s)end? $ECHON2"
482 if [ $CNT -eq 6 ]; then
490 if [ -z "$BATCH" ]; then
491 echo "$COMMAND: the problem report remains in $BAD and is not sent."
492 REMOVE_TEMP
="rm -f $TEMP0 $TEMP $REF"
495 echo "$COMMAND: the problem report is not sent."
511 # Make sure the mail has got a Subject. If not, use the same as
515 if grep '^Subject:[ ]*$' $TEMP > /dev
/null
517 SYNOPSIS
=`grep '^>Synopsis:' $TEMP | sed -e 's/^>Synopsis:[ ]*//'`
518 ed
-s $TEMP << __EOF__
519 /^Subject:/s/:.*\$/: $SYNOPSIS/
526 # Remove comments and send the problem report
527 # (we have to use patterns, where the comment contains regex chars)
529 # /^>Originator:/s;$ORIGINATOR;;
532 /^>Organization:/,/^>[A-Za-z-]*:/s;$ORGANIZATION_C;;
533 /^>Confidential:/s;<.*>;;
534 /^>Synopsis:/s;$SYNOPSIS_C;;
535 /^>Severity:/s;<.*>;;
536 /^>Priority:/s;<.*>;;
537 /^>Category:/s;$CATEGORY_C;;
539 /^>Release:/,/^>[A-Za-z-]*:/s;$RELEASE_C;;
540 /^>Environment:/,/^>[A-Za-z-]*:/s;$ENVIRONMENT_C;;
541 /^>Description:/,/^>[A-Za-z-]*:/s;$DESCRIPTION_C;;
542 /^>How-To-Repeat:/,/^>[A-Za-z-]*:/s;$HOW_TO_REPEAT_C;;
543 /^>Fix:/,/^>[A-Za-z-]*:/s;$FIX_C;;
546 if $MAIL_AGENT < $REF; then
547 echo "$COMMAND: problem report sent"
550 echo "$COMMAND: mysterious mail failure."
551 if [ -z "$BATCH" ]; then
552 echo "$COMMAND: the problem report remains in $BAD and is not sent."
553 REMOVE_TEMP
="rm -f $TEMP0 $TEMP $REF"
556 echo "$COMMAND: the problem report is not sent."